#ifndef __OPENSSL_HANDLER_H__
#define __OPENSSL_HANDLER_H__

#include <stdio.h>
#include "../comm_src/fgsdk_common.h"

#include <openssl/rsa.h>   
#include <openssl/evp.h>   
#include <openssl/objects.h>   
#include <openssl/x509.h>   
#include <openssl/err.h>   
#include <openssl/pem.h>   
#include <openssl/ssl.h>   
#include <openssl/pkcs12.h>
#include <openssl/rand.h>
#include "openssl/ts.h"
#include <openssl/pkcs7.h>

#include <string>
using std::string;

#define TIMESTAMP_DOC 1
#define TIMESTAMP_SIG 2

typedef struct _timeStampParam
{
	FSCRT_BSTR	inputFile;
	FS_INT32	*pageRange;
	FS_INT32	pageNum;
	FSCRT_BSTR	outputFile;
	FSCRT_BSTR	certFile;
	FSCRT_BSTR	certPwd;
	FSCRT_BSTR	tsaHost;
	FSCRT_BSTR	tsaReqUrl;
	FS_INT32	port;
	FSCRT_BSTR	tsaUserNPswd;
	FS_INT32	TSType;
	FSCRT_BSTR	subfilter;
}TIMESTAMP_PARAM;


FS_BOOL parseParam(int argc, char *argv[], TIMESTAMP_PARAM *out);

FS_BOOL validateParam(TIMESTAMP_PARAM *out);

void switchSubfilter(TIMESTAMP_PARAM*param);

void clearParam(TIMESTAMP_PARAM *out);

FS_RESULT getTextFromFile(FSCRT_FILE file, const FS_DWORD *byteRange, unsigned char *plainString);

void initialize_openssl();

unsigned char* PKCS7_Sign(TIMESTAMP_PARAM *TSParam, const FSCRT_BSTR* bstrPlainText,int& retSize, FS_BOOL onlyTS = FALSE);

FS_BOOL PKCS7_VerifySig(const FSCRT_BSTR* signedData, const FSCRT_BSTR* bstrPlainText, FS_BOOL onlyTs = FALSE);

#endif